'**********************************************
DAT
  dummy1 long 0[368] ' Value of 369 or more fails, 368 and below works


CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  NEW_LINE = 10

OBJ
  app : "hello"
  c : "clib"
  ymodem : "ymodemx"
  eeprom : "Basic_I2C_Driver"

DAT
  buffer byte 0[100]
  argv long 0[20]
  strbuf byte 0[100]
  
DAT
  redirectin long 0
  redirectout long 0
  commands byte "dir", 0, "delete", 0, "create", 0, "append", 0, "type", 0, "dumpf", 0
  byte "load", 0, "save", 0, "exit", 0, "format", 0, "dump", 0, "peek", 0, "poke", 0
  byte "dumpm", 0, "peekm", 0, "pokem", 0, "appcall", 0, "appinfo", 0, "appsave", 0
  byte "appload", 0, "stack", 0, "malloc", 0, "pwd", 0, "cd", 0, "help", 0, 0

PUB main | i, blocklongs, num, index, outfile, infile, argc, startaddr, endaddr, TopAddr, TopObjList
{
  TopAddr := 16
  TopObjList := TopAddr + (byte[TopAddr + 2] << 2)
  startaddr := word[TopObjList][0] + TopAddr
  endaddr := word[TopObjList][2] + TopAddr - 1
  c.start2(31, 30, %10000, 57600, startaddr, endaddr)
}
  c.start
  repeat
    c.printf0(string("Press any key to start\n"))
    if (c.getch <> -1)
      quit
    waitcnt(clkfreq+cnt)
  'c.CheckStackSpace
  'c.CheckMallocSpace
  'c.DumpMallocTraceBuf
  help
  ifnot c.mount(1, string("disk1"))
    c.printf0(STRING("\nDisk1 does not contain a valid file system.\n"))
    c.printf0(STRING("Use the format command to initialize the file system\n"))
  ifnot c.mount(2, string("disk2"))
    c.printf0(STRING("\nDisk2 does not contain a valid file system.\n"))
    c.printf0(STRING("Use the format command to initialize the file system\n"))
  c.chdir(string("/"))
  REPEAT
    ' Close redirection files if opened
    if redirectin
      c.resetstdin
      c.fclose(redirectin)
      redirectin := 0
    if redirectout
      c.resetstdout
      c.fclose(redirectout)
      redirectout := 0

    c.printf0(STRING("\n>"))
    c.gets(@buffer)
    'c.printf2(string("len = %d, buffer = %s\n"), strsize(@commands), @commands)
    'c.printf2(string("len = %d, buffer = %s\n"), strsize(@buffer), @buffer)
    'c.vprintf(string("buffer = %08x %08x"), @buffer)
    'argc := 1
    'argv[0] := @buffer
    argc := tokenize(@buffer, @argv)
    argc := Redirection(argc)
    'c.printf1(string("argc = %d\n"), argc)

    IF (argc == 0)
      NEXT

    num := 0
    index := @commands
    repeat while byte[index]
      if c.strcmp(argv[0], index) == 0
        quit
      index += strsize(index) + 1
      num++

    case num
      0 :
        PrintDirectory
      1 :
        ifnot c.remove(argv[1])
          c.printf1(STRING("%s not found\n"), argv[1])
      2 :
        index := c.create(argv[1])
        if index == 0
          c.printf1(STRING("%s already exists\n"), argv[1])
        elseif index == -1
          c.printf0(STRING("Disk is full\n"))
      3 :
        REPEAT
          c.gets(@strbuf)
          IF (strbuf[0] == 0)
            QUIT
          FileAppend(argv[1], @strbuf)
      4 :
        FilePrint(argv[1])
      5 :
        HexDumpFile(argv[1])
      {
      6 :
        LoadFile(argv[1])
      }
      7 :
        SaveFile(argv[1])
      8 :
        quit
      9 :
        c.printf0(STRING("Are you sure you want to format the file system (yes/no)? "))
        c.gets(@buffer)
        IF (c.strcmp(@buffer, STRING("yes")) == 0)
          c.printf0(string("Formatting started\n"))
          c.format
          c.printf0(STRING("Formatting completed\n"))
          'c.printf0(STRING("Use the \042appcall\042 command to write application files\n"))
        else
          c.printf0(STRING("format aborted\n"))
      10 :
        c.sscanf1(argv[1], STRING("%x"), @index)
        c.sscanf1(argv[2], STRING("%x"), @num)
        repeat i from 0 to num - 1
          if ((i & 15) == 0)
            c.printf1(STRING("\n%05x:"), i + index)
          c.printf1(STRING(" %02x"), eeprom.ReadByte(28, $A0, i + index))
        c.printf0(STRING("\n"))
      11 :
        c.sscanf1(argv[1], STRING("%x"), @index)
        c.printf2(STRING("EEPROM[%04x] = %02x\n"), index, eeprom.ReadByte(28, $A0, index))
      12 :
        c.sscanf1(argv[1], STRING("%x"), @index)
        c.sscanf1(argv[2], STRING("%x"), @num)
        eeprom.WriteByte(28, $A0, index, num)
        repeat while eeprom.WriteWait(28, $A0, index)
      13 :
        c.sscanf1(argv[1], STRING("%x"), @index)
        c.sscanf1(argv[2], STRING("%x"), @num)
        DumpMemory(index, num)
      14 :
        c.sscanf1(argv[1], STRING("%x"), @index)
        c.printf2(STRING("Memory[%04x] = %02x\n"), index, byte[index])
      15 :
        c.sscanf1(argv[1], STRING("%x"), @index)
        c.sscanf1(argv[2], STRING("%x"), @num)
        byte[index] := num
      16 :
        app.main(argc, @argv)
        'c.printf1(STRING("Return code = %d\n"), app.main(num, @argv))
      17 :
        AppInfo
      18:
        AppSave(argv[1])
      19:
        'if AppLoad(argv[1]) == 0
         ' c.printf1(STRING("Could not open input file %s\n"), argv[1])
      20:
        c.CheckStackSpace
      21:
        c.CheckMallocSpace
        'c.DumpMallocTraceBuf
      22:
        c.getcwd(@buffer, 100)
        c.printf1(string("%s\n"), @buffer)
      23:
        ifnot c.chdir(argv[1])
          c.printf1(string("Could not find path %s\n"), argv[1])
      24:
        help
      other:
        if c.strcmp(argv[0], string("echo")) == 0
          echo(argc)
        elseif c.strcmp(argv[0], string("cat")) == 0
          cat(argc, @argv)
        elseif c.strcmp(argv[0], string("cp")) == 0
          cp(argc, @argv)
        elseif c.strcmp(argv[0], string("rb")) == 0
          ymodem.ReceiveFile
        elseif c.strcmp(argv[0], string("sb")) == 0
          ymodem.SendFile(argc, @argv)
        elseif c.strcmp(argv[0], string("catseek")) == 0
          catseek(argc, @argv)
        elseif c.strcmp(argv[0], string("speedtest")) == 0
          SpeedTest
        elseif strcomp(argv[0], string("mkdir"))
          c.mkdir(argv[1])
        elseif strcomp(argv[0], string("chmod"))
          if argc == 3
            c.sscanf1(argv[2], string("%b"), @i)
            c.chmod(argv[1], i)
        elseif strcomp(argv[0], string("rename"))
          if argc <> 3
            c.printf0(string("usage: rename fname1 fname2\n"))
          else
            c.rename(argv[1], argv[2])
        elseifnot AppLoad(argc, @argv)
          c.printf1(string("The file %s does not exist\n"), argv[0])

PUB SpeedTest | cycles, xfile, xbuf
  xbuf := c.malloc(400)
  xfile := c.fopen(string("tempfile"), string("w"))
  cycles := cnt
  repeat 10
    c.fwrite(xbuf, 1, 400, xfile)
  cycles := cnt - cycles
  c.fclose(xfile)
  c.printf1(string("4000 bytes written in %d msecs\n"), cycles / 80000)
  xfile := c.fopen(string("tempfile"), string("r"))
  cycles := cnt
  repeat 10
    c.fread(xbuf, 1, 400, xfile)
  cycles := cnt - cycles
  c.fclose(xfile)
  c.printf1(string("4000 bytes read in %d msecs\n"), cycles / 80000)
  c.free(xbuf)

PUB echo(argc) | i
  if argc > 1
    repeat i from 1 to argc - 1
      c.printf1(string("%s"), argv[i])
      if i <> argc - 1
        c.printf1(string("%c"), 32)
    c.printf1(string("%c"), NEW_LINE)

PUB cat(argc, pargv) | i, buffer1, infile, value_0
  buffer1 := c.malloc(400)
  ifnot buffer1
    c.printf0(string("Could not malloc buffer\n"))
  i := 1
  repeat
    if (argc < 2 OR c.strcmp(LONG[pargv][i], STRING("-")) == 0)
      infile := c.getstdin
    else
      'c.printf1(string("Opening %s\n"), long[pargv][i])
      infile := c.fopen(long[pargv][i], STRING("r"))
      IF (infile == 0)
        c.printf1(STRING("Error opening %s\n"), long[pargv][i])
        c.free(buffer1)
        RETURN 1
    REPEAT WHILE ((value_0 := c.fgetc(infile)) => 0)
      IF (value_0 == 0)
        c.printf0(STRING("\n"))
      elseif (value_0 == 4)
        quit
      else
        c.printf1(STRING("%c"), value_0)
    IF (infile <> c.getstdin)
      c.fclose(infile)
    i++
  WHILE (i < argc)
  c.free(buffer1)

PUB catseek(argc, pargv) | i, buffer1, infile, value_0
  infile := c.fopen(long[pargv][1], string("r"))
  ifnot infile
    c.printf1(string("Could not open %s\n"), long[pargv][1])
    return
  c.fseek(infile, 0, c#SEEK_END)
  c.printf1(string("file size is %d\n"), c.ftell(infile))
  c.sscanf1(long[pargv][2], string("%d"), @i)
  c.fseek(infile, i, c#SEEK_SET)
  REPEAT WHILE ((value_0 := c.fgetc(infile)) => 0)
    IF (value_0 == 0)
      c.printf0(STRING("\n"))
    elseif (value_0 == 4)
      quit
    else
      c.printf1(STRING("%c"), value_0)
  c.fclose(infile)

PUB cp(argc, pargv) | num, infile, outfile, buf[25]
  if argc == 3
    if c.strcmp(long[pargv][1], long[pargv][2]) == 0
      argc := 0
  if argc <> 3
    c.printf0(string("usage: cp file1 file2\n"))
    return 1
  infile := c.fopen(long[pargv][1], string("r"))
  ifnot infile
    c.printf1(string("Could not open input file %s\n"), long[pargv][1])
    return 1
  outfile := c.fopen(long[pargv][2], string("w"))
  ifnot outfile
    c.printf1(string("Could not open output file %s\n"), long[pargv][2])
    return 1
  repeat while (num := c.fread(@buf, 1, 100, infile)) > 0
    c.fwrite(@buf, 1, num, outfile)
  c.fclose(infile)
  c.fclose(outfile)

PUB Redirection(argc) | i, argc1, ptr, char, mode
  if (argc < 2)
    return argc
  argc1 := 1
  repeat i from 1 to argc - 1
    ptr := argv[i]
    char := byte[ptr++]
    if char == "<"
      if (byte[ptr] == 0)
        ptr := argv[++i]
        if (i => argc)
          c.printf0(string("Redirection error\n"))
          argc1 := 0
          quit
      redirectin := c.fopen(ptr, string("r"))
      ifnot redirectin
        c.printf1(string("Could not open %s for input\n"), ptr)
        argc1 := 0
        quit
      else
        c.setstdin(redirectin)
    elseif char == ">"
      if (byte[ptr] == ">")
        ptr++
        mode := string("a")
      else
        mode := string("w")
      if (byte[ptr] == 0)
        ptr := argv[++i]
        if (i => argc)
          c.printf0(string("Redirection error\n"))
          argc1 := 0
          quit
      redirectout := c.fopen(ptr, mode)
      ifnot redirectout
        c.printf1(string("Could not open %s for output\n"), ptr)
        argc1 := 0
        quit
      else
        c.setstdout(redirectout)
    else
      argv[argc1++] := argv[i]
  return argc1

PUB PrintDirectory | handle, filesize, numfiles, numbytes, attrib, astr[2], aptr, pdirent          
  numfiles := 0
  numbytes := 0
  handle := c.opendir(@numbytes)
  repeat while (pdirent := c.readdir(handle))
    filesize := long[pdirent][1]
    attrib := long[pdirent][0]
    numbytes += filesize
    aptr := @astr
    c.strcpy(aptr, string("drwx"))
    repeat 4
      ifnot attrib & 8
        byte[aptr] := "-"
      aptr++
      attrib <<= 1
    c.printf3(STRING("%s %8d %s\n"), @astr, filesize, pdirent + 8)
    numfiles++
  c.printf2(STRING("%6d files, %d bytes\n"), numfiles, numbytes)
  c.closedir(handle)

PUB LoadFile(fname) | addr_1, num, instr[5], infile
  infile := c.fopen(fname, STRING("r"))
  IF (infile == 0)
    c.printf1(STRING("File %Rs not found\n"), fname)
    RETURN
  num := c.fread(@addr_1, 1, 4, infile)
  IF (num == 4)
    num := c.fread(addr_1, 1, 100000, infile)
    c.printf2(STRING("%d bytes loaded starting at %04x\n"), num, addr_1)
  c.fclose(infile)

PUB SaveFile(fname) | addr_1, num, instr[5], outfile
  outfile := c.fopen(fname, STRING("w"))
  IF (outfile == 0)
    c.printf1(STRING("Could not open output file %s\n"), fname)
    RETURN
  c.printf0(STRING("Enter starting address in hex: "))
  c.gets(@instr)
  c.sscanf1(@instr, STRING("%x"), @addr_1)
  c.printf0(STRING("Enter number of bytes in decimal: "))
  c.gets(@instr)
  c.sscanf1(@instr, STRING("%d"), @num)
  c.fwrite(@addr_1, 1, 4, outfile)
  c.fwrite(addr_1, 1, num, outfile)
  c.fclose(outfile)

PUB HexDumpFile(fname) | i, num, j, buf[4], infile
  j := 0
  infile := c.fopen(fname, STRING("r"))
  IF (infile == 0)
    c.printf1(STRING("File %s not found\n"), fname)
    RETURN
  REPEAT WHILE ((num := c.fread(@buf, 1, 16, infile)) > 0)
    c.printf1(STRING("%04x"), j)
    j += 16
    i := 0
    REPEAT WHILE (i < num)
      c.printf1(STRING(" %02x"), BYTE[@buf][i])
      i++
    c.printf0(STRING("\n"))
  c.fclose(infile)

PUB FilePrint(fname) | value_0, infile
  'c.CheckMallocSpace
  infile := c.fopen(fname, STRING("r"))
  IF (infile == 0)
    c.printf1(STRING("File %s not found\n"), fname)
    RETURN
  'c.CheckMallocSpace
  REPEAT WHILE ((value_0 := c.fgetc(infile)) => 0)
    'c.CheckMallocSpace
    IF (value_0 == 0)
      c.printf0(STRING("\n"))
    else
      c.printf1(STRING("%c"), value_0)
  'c.CheckMallocSpace
  c.fclose(infile)
  'c.CheckMallocSpace
  
' This routine appends a string to the end of a file
PUB FileAppend(fname, str) | outfile
  'c.printf1(string("Call fopen %s\n"), fname)
  outfile := c.fopen(fname, STRING("a"))
  IF (outfile == 0)
    c.printf1(STRING("Could not open %s\n"), fname)
    RETURN
  c.fputs(str, outfile)
  c.fputc(NEW_LINE, outfile)
  c.fclose(outfile)
  
' This routine returns a pointer to the first character not
' matching the passed value
PUB SkipChar(str, value_0)
  REPEAT WHILE (BYTE[str])
    IF (BYTE[str] <> value_0)
      QUIT
    str++
  RETURN str
  
' This routine returns a pointer to the first charcter that
' matches the passed value
PUB FindChar(str, value_0)
  REPEAT WHILE (BYTE[str])
    IF (BYTE[str] == value_0)
      QUIT
    str++
  RETURN str
  
' This routine extracts tokens from the input string that
' are seperated by at least one space character
PUB tokenize(ptr, tokens) | num
  num := 0
  repeat
    ptr := SkipChar(ptr, " ")
    ifnot byte[ptr]
      quit
    num++
    if byte[ptr] == $22
      long[tokens] := ++ptr
      ptr := FindChar(ptr, $22)
    else
      long[tokens] := ptr
      ptr := FindChar(ptr, " ")
    tokens += 4
    IF (BYTE[ptr] == 0)
      QUIT
    BYTE[ptr++] := 0
  RETURN num
  
' This routine prints the commands
PUB help
  c.printf0(STRING("Commands\n"))
  c.printf0(STRING("help                - Print commands\n"))
  c.printf0(STRING("format              - Initialize the file system\n"))
  c.printf0(STRING("dir                 - Directory listing\n"))
  c.printf0(STRING("delete  filename    - Delete file\n"))
  c.printf0(STRING("create  filename    - Create file\n"))
  c.printf0(STRING("append  filename    - Append text to file\n"))
  c.printf0(STRING("type    filename    - Type file\n"))
  c.printf0(STRING("dumpf   filename    - Dump file in hex\n"))
  c.printf0(STRING("save    filename    - Save memory to file\n"))
  c.printf0(string("cat file1 file2 ... - Unix/Linux cat command\n"))
  c.printf0(string("echo                - Unix/Linux echo command\n"))
  c.printf0(string("cp  file1 file2     - Copy file1 to file2\n"))
  c.printf0(string("mkdir directory     - Create a directory\n"))
  c.printf0(string("chmod file mode     - Change file mode bits\n"))
  c.printf0(string("rename file1 file2  - Rename file1 to file2\n"))
  c.printf0(string("\n"))
  c.printf0(string("sb filename         - Send a file using YModem\n"))
  c.printf0(string("rb                  - Receive a file using YModem\n"))
  c.printf0(STRING("stack               - Print the amount of unused stack space\n"))
  c.printf0(STRING("malloc              - Print the malloc and free lists\n"))
  c.printf0(string("catseek             - Run seek test\n"))
  c.printf0(string("speedtest           - Write and Read a 4000-byte file\n"))
  {
  c.printf0(STRING("load    filename    - Load memory from file\n"))
  c.printf0(STRING("exit                - Exit program\n"))
  }
  c.printf0(STRING("peek  address       - Print value at address in EEPROM\n"))
  c.printf0(STRING("poke  address num   - Write value at address in EEPROM\n"))
  c.printf0(STRING("dump  address num   - Print num values statring at address in EEPROM\n"))
  c.printf0(STRING("peekm address       - Print value at address in memory\n"))
  c.printf0(STRING("pokem address num   - Write value at address in memory\n"))
  c.printf0(STRING("dumpm address num   - Print num values statring at address in memory\n"))
  c.printf0(STRING("appinfo             - Print out information on the app loaded in memory\n"))
  c.printf0(STRING("appcall             - Call the current app that is loaded in memory\n"))
  c.printf0(STRING("appload filename    - Load an app file into memory\n"))
  c.printf0(STRING("appsave filename    - Save the current app loaded in memory to a file\n"))
  c.printf0(STRING("filename            - Load and call an application file\n"))

PUB DumpMemory(address, num) | i, ptr
  ptr := address
  i := 0
  REPEAT WHILE (i < num)
    IF ((i & 15) == 0)
      c.printf1(STRING("\n%05x:"), i + address)
    c.printf1(STRING(" %02x"), BYTE[ptr][i])
    i++
  c.printf0(STRING("\n"))
  
' This is the main routine for testing the EEPROM File System
PUB AppInfo | AppAddr, NumMethods, NumObjects, i
  AppAddr := word[16] + 16
  c.printf2(string("App address = %04x, App size = %x bytes\n"), AppAddr, word[AppAddr])
  NumMethods := byte[AppAddr + 2]
  NumObjects := byte[AppAddr + 3]
  c.printf2(string("App contains %d methods, and uses %d objects\n"), NumMethods-1, NumObjects)
  AppAddr += NumMethods << 2
  repeat i from 0 to NumObjects - 1
    c.printf2(string("Object %d is at offset %x\n"), i, word[AppAddr])
    AppAddr += 4

PUB AppSave(fname) | outfile, index, num
  outfile := c.fopen(fname, STRING("w"))
  IF (outfile == 0)
    c.printf1(STRING("Could not open output file %s\n"), fname)
    return
  index := word[16] + 16
  num := $63657845
  c.fwrite(@num, 1, 4, outfile)
  num := word[index]
  c.fwrite(index, 1, num, outfile)
  c.fclose(outfile)

PUB AppLoad(argc, pargv) | infile, num, AppAddr, TopAddr, AppObjList, TopObjList, size
  infile := c.fopen(long[pargv], STRING("r"))
  IF (infile == 0)
    return 0
  c.fread(@num, 1, 4, infile)
  if num <> $63657845
    c.printf1(string("%s is not an executable file\n"), long[pargv])
    c.fclose(infile)
    return 0
  ' Determine the file size
  c.fseek(infile, 0, c#SEEK_END)
  size := c.ftell(infile)
  c.fseek(infile, 0, c#SEEK_SET)
  AppAddr := c.malloc(size)
  ifnot AppAddr
    return 0
  c.fread(@num, 1, 4, infile)
  c.fread(AppAddr, 1, size, infile)
  c.fclose(infile)
  ' Fix up the object offsets
  TopAddr := 16
  TopObjList := TopAddr + (byte[TopAddr + 2] << 2)
  AppObjList := AppAddr + (byte[AppAddr + 2] << 2)
  word[AppAddr][0] := word[TopObjList][2] + TopAddr - AppAddr  
  word[AppObjList][0] := word[TopObjList][2] + TopAddr - AppAddr
  word[TopObjList][0] := AppAddr - TopAddr
  app.main(argc, pargv)
  c.free(AppAddr)
  return 1