OBJ
  fsrw : "fsrw"
  ser : "cserial"

CON
  FIRST_PIN = 16

DAT
  readdir_block long 0[8] 'attrib, size, fname

'****************************************************************
' Public API Methods
'****************************************************************
PUB handlesize
  return 4

PUB mount
  result := (fsrw.mount(FIRST_PIN) == 0)  

PUB format
  
PUB remove(fname)
  result := (fsrw.popen(fname, "d") == 0)

PUB open(handle, fname, mode) | retval
  ifnot handle
    return
  if strcomp(fname, string("root"))
    retval := fsrw.opendir
  else
    retval := fsrw.popen(fname, byte[mode])
  ifnot retval
    long[handle] := 1
    result := handle
  else
    long[handle] := 0

PUB close(handle) | retval
  ifnot fsrw.pclose
    result := 1

' This routine writes a chunk to a file
PUB write(handle, buffer, num)
  result := fsrw.pwrite(buffer, num)
  if result < 0
    result := 0

' This routine reads a chunk from a file
PUB read(handle, buffer, num)
  result := fsrw.pread(buffer, num)
  if result < 0
    result := 0

PUB opendir(path)
  fsrw.opendir
  return 1

PUB readdir(handle) | retval, attrib, filesize, fname[4], ptr1, ptr2, val
  if handle == 0
    return
    
  ptr2 := @readdir_block
  repeat
    retval := fsrw.pread(ptr2, 32) ' Read a directory entry
    if retval < 0
      return
    ifnot byte[ptr2] ' Check for the end of the directory
      return
    attrib := byte[ptr2 + 11] ' Get the attribute byte
    if (byte[ptr2] <> $e5) and ((attrib & $08) == 0) ' Exit loop if a valid file or directory entry
      quit
      
  filesize := readdir_block[7] ' Get the file size
  attrib := %0010 | (((attrib&1)^1)<<2) | (((attrib&%10000)<>0)&%1001) ' Set the "dwrx" bits
  ptr1 := @fname
  ' Get up to eight file name characters
  repeat 8
    val := byte[ptr2++]
    if val =< 32 or val > 126
      quit
    byte[ptr1++] := val
  ' Check for an extension  
  ptr2 := @readdir_block[2]
  val := byte[ptr2]
  if val > 32 and val =< 128
    byte[ptr1++] := "."
    ' Get up to 3 extension characters
    repeat 3
      val := byte[ptr2++]
      if val =< 32 or val > 126
        quit
      byte[ptr1++] := val
  byte[ptr1] := 0 ' NULL terminate the file name string
  readdir_block[0] := attrib ' Put attribute bits in the first long
  readdir_block[1] := filesize ' Put the file size in the second long
  bytemove(@readdir_block[2], @fname, 13) ' Put the file name starting at the third long
  return @readdir_block 

PUB closedir(handle)
  fsrw.pclose

PUB chdir(path)

PUB getfilesize(handle)
  ifnot handle
    return
  result := fsrw.get_filesize

PUB seek(handle, position)
  result := fsrw.seek(position)

PUB tell(handle)
  result := fsrw.tell

PUB flush(handle)
  result := fsrw.pflush

PUB mkdir(fname)

PUB chmod(fname, modebits)

PUB rename(fname1, fname2)